import Flutter
import UIKit

public class SwiftFlutterMiPushPlugin: NSObject, FlutterPlugin, MiPushSDKDelegate, UNUserNotificationCenterDelegate {
  var TAG = "SwiftFlutterMiPushPlugin:";
  
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_mi_push", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterMiPushPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    result("iOS " + UIDevice.current.systemVersion)
    if (call.method == "init") {
      initPush(result: result)
    }
  }

  private func initPush(result: @escaping FlutterResult) {
    MiPushSDK.registerMiPush(self, type: UIRemoteNotificationType(rawValue: UInt(0)), connect: true)
    result("success")
  }
  
  private func miPushRequestSucc(withSelector selector: String!, data: [AnyHashable : Any]!) {
    print(TAG + "miPushRequestSucc, selector = " + selector + ", data = " + data.description)
  }
  
  private func miPushRequestErr(withSelector selector: String!, error: Int32, data: [AnyHashable : Any]!) {
    print(TAG + "miPushRequestErr, selector = " + selector + ", error = " + error.description + ", data = " + data.description)
  }
  
  private func miPushReceiveNotification(_ data: [AnyHashable : Any]!) {
    print(TAG + "miPushReceiveNotification, data = " + data.description)
  }
}
